import axios from 'axios';
import qs from 'qs';
axios.defaults.withCredentials = true;
export default class Net {
  static get(url, params) {
    return new Promise((resolve, reject) => {
      axios({
          method: 'get',
          url,
          params,
          headers: {
            // Authorization: localStorage.getItem('token') || ""
            Authorization: localStorage.getItem('token') ? JSON.parse(localStorage.getItem('token')) : "",
            'Content-Type': 'application/json;charset=utf-8'
          }
        })
        .then((res) => {
          this.successTodo(resolve, reject, res);
        })
        .catch((error) => {
          this.errTodo(error, url);
        });
    });
  }

  static post(url, params, option = {}) {
    return new Promise((resolve, reject) => {
      let data = params;
      if(option['Content-Type'] === "application/x-www-form-urlencoded"){
        data = qs.stringify(data);
      } else {
        data = JSON.stringify(data);
      }
      const headers =
        localStorage.getItem('token') ? {
          Authorization: JSON.parse(localStorage.getItem('token')),
          'Content-Type': 'application/json;charset=utf-8',
          ...option
        } : {
          Authorization: '',
          'Content-Type': 'application/json;charset=utf-8',
          ...option
        };
      axios({
          method: 'post',
          url,
          data: data,
          // data: params,
          headers: headers
        })
        .then((res) => {
          this.successTodo(resolve, reject, res);
        })
        .catch((error) => {
          this.errTodo(error, url);
        });
    });
  }

  // 处理异常方法
  static successTodo(resolve, reject, val) {
    let retcode = parseInt(val.data.code);
    if (retcode === 200) {
      resolve(val.data.data);
    } else if (retcode === 201) {
      router.push('/login');
      localStorage.removeItem('token');
      reject(val.data.msg);
    } else {
      reject(val.data.msg);
    }
  }

  // 处理异常方法
  static errTodo(error) {
    console.log(error)
  }
}